<div id="overlay"></div>
<style>
    #overlay {
        width: 100%;
        height: 100%;
        visibility: hidden;
        position: absolute;
        top: 5px;
        left: 5px;
    }
</style>

<script>
    /* Overlay init */
    const overlay = d3.select('#overlay');

    const svgOverlay = overlay.append('svg')
        .attr('width', "100%")
        .attr('height', "100%");

    const gOverlay = svgOverlay.append('g')
        .attr('opacity', 0)
        .style('visibility', 'hidden');

    /* Overlay functions */
    const showOverlay = x => {
        gOverlay.selectAll('.overlay-text')
            .remove();
        gOverlay.selectAll('.overlay-rect')
            .remove();

        const overlayText = gOverlay.append('text')
            .attr('x', 6)
            .attr('y', 20)
            .attr('fill', 'white')
            .attr('class', 'overlay-text');

        Object.keys(x).forEach((key, idx) => {
            overlayText.append('tspan')
                .text(key.charAt(0).toUpperCase() + key.slice(1) + ": " + x[key])
                .attr('x', 5)
                .attr('dy', (idx > 0) ? 20 : 0);
        });

        const textBoundingRect = d3.select('.overlay-text').node().getBBox();

        gOverlay.insert('rect', '.overlay-text')
            .attr('class', 'overlay-rect')
            .attr('width', textBoundingRect.width + 11)
            .attr('height', textBoundingRect.height + 12)
            .attr('fill', 'black')
            .attr('opacity', 0.5);

        gOverlay.transition()
            .duration(transitionDuration)
            .style('opacity', 1)
            .style('visibility', 'visible');
    };

    const hideOverlay = () => {
        gOverlay.transition().duration(transitionDuration).style('opacity', 0).style('visibility', 'hidden');

        gOverlay.selectAll('.overlay-text')
            .remove();
        gOverlay.selectAll('.overlay-rect')
            .remove();
    };
</script>